; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : C++ Class Interface Example 01
; File Name : C++ Class Interface Example 01.pb
; File version: 4.0.0
; Programming : OK
; Programmed by : StarBootics
; Date : 26-10-2016
; Last Update : 26-10-2016
; PureBasic code : V5.50
; Platform : Linux x64
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;
; In this example we will create a Module to drive
; a C++ Class Interface directly from a *.so 
; library.
;
; This code is free to be use where ever you like 
; but you use it at your own risk.
;
; The author can in no way be held responsible 
; for data loss, damage or other annoying 
; situations that may occur.
;
; This example has been tested only on linux x64 but
; should work on Linux x86, MacOS and Windows x64 as
; is.
;
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

IncludeFile "Version - Module.pb"

DeclareModule TimeDate
  
  Interface Time
    
    Update(Hour.l, Minute.l, Second.l)
    UpdateEx(*Ptr)
    SetHour(Hour.l)
    SetMinute(Minute.l)
    SetSecond(Second.l)
    GetHour.l()
    GetMinute.l()
    GetSecond.l()
    Refresh()
    Version(*Ptr.Version::Version)
    
  EndInterface
  
  Interface Date
    
    Update(day.l, month.l, year.l)
    SetDay(day.l)
    SetMonth(month.l)
    SetYear(year.l)
    GetDay.l()
    GetMonth.l()
    GetYear.l()
    Refresh()
    Version(*Ptr.Version::Version)
    
  EndInterface
  
  ImportC "source/bin/Release/libtime.so"
    
    NewTime() As "CreateTimeInterface"
    NewTimeEx(hour.l, minute.l, second.l) As "CreateTimeInterfaceEx"
    DeleteTime.l(*Ptr.Time) As "DeleteTimeInterface"
    NewDate() As "CreateDateInterface"
    DeleteDate.l(*Ptr.Date) As "DeleteDateInterface"
    LibTimeVersion(*Ptr.Version::Version) As "GetVersion"
    
  EndImport 
  
  Declare.s FormattingTime(*P_Time.Time)
  Declare.s FormattingDate(*P_Date.Date)
  
EndDeclareModule

Module TimeDate
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Formatting operators <<<<<
  
  Procedure.s FormattingTime(*P_Time.Time)
    
    ProcedureReturn RSet(Str(*P_Time\GetHour()), 2, "0") + ":" + RSet(Str(*P_Time\GetMinute()), 2, "0") + ":" + RSet(Str(*P_Time\GetSecond()), 2, "0")
  EndProcedure
  
  Procedure.s FormattingDate(*P_Date.Date)
    
    ProcedureReturn RSet(Str(*P_Date\GetDay()), 2, "0") + "-" + RSet(Str(*P_Date\GetMonth()), 2, "0") + "-" + RSet(Str(*P_Date\GetYear()), 4, "0")
  EndProcedure
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Structure Time
    
    Hour.l
    Minute.l
    Second.l
    
  EndStructure
  
  MyTime.TimeDate::Time = TimeDate::NewTimeEx(15, 09, 55) 
  MyDate.TimeDate::Date = TimeDate::NewDate()
  
  MyDate\Update(25, 10, 2015)
  Debug TimeDate::FormattingTime(MyTime) + " " + TimeDate::FormattingDate(MyDate)
  
  CurrentTime.Time\Hour = Hour(Date())
  CurrentTime.Time\Minute = Minute(Date())
  CurrentTime.Time\Second = Second(Date())
  
  MyTime\UpdateEx(CurrentTime)
  MyDate\Update(Day(Date()), Month(Date()), Year(Date()))
  
  Debug TimeDate::FormattingTime(MyTime) + " " + TimeDate::FormattingDate(MyDate)

  MyTime\Version(TimeVersion.Version::Version)
  MyDate\Version(DateVersion.Version::Version)
  TimeDate::LibTimeVersion(GeneralVersion.Version::Version)
  
  Debug "Time Version : " + Version::Format(TimeVersion)
  Debug "Date Version : " + Version::Format(DateVersion)
  Debug "LibTime Version : " + Version::Format(GeneralVersion)
  
  MyTime = TimeDate::DeleteTime(MyTime)
  MyDate = TimeDate::DeleteDate(MyDate)

  If MyTime = 0
    Debug "MyTime no longer exist"
  EndIf
  
  If MyDate = 0
    Debug "MyDate no longer exist"
  EndIf 
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 (Linux - x64)
; Folding = --
; EnableXP
; CompileSourceDirectory