; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Version Module
; Nom du fichier : Version - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : StarBootics
; Date : 16-03-2015
; Mise  jour : 16-03-2015
; Cod pour : PureBasic 5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Version

  Structure Version

    Major.a
    Minor.a
    Patch.a

  EndStructure
  
  Declare Update(*VersionA.Version, P_Major.a, P_Minor.a, P_Patch.a)
  Declare Reset(*VersionA.Version)
  Declare Copy(*VersionA.Version, *VersionB.Version)
  Declare Compare(*VersionA.Version, *VersionB.Version)
  Declare Swapping(*VersionA.Version, *VersionB.Version)
  Declare ReadVersion(FileID.l, *VersionA.Version)
  Declare WriteVersion(FileID.l, *VersionA.Version)
  Declare.s Format(*VersionA.Version)
  Declare Unformat(*VersionA.Version, P_Version.s)
  Declare.l To_Long(*VersionA.Version)
  Declare From_Long(*VersionA.Version, LongVar.l)
  
EndDeclareModule

Module Version

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Update <<<<<

  Procedure Update(*VersionA.Version, P_Major.a, P_Minor.a, P_Patch.a)

    *VersionA\Major = P_Major
    *VersionA\Minor = P_Minor
    *VersionA\Patch = P_Patch

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset(*VersionA.Version)
    
    *VersionA\Major = 0
    *VersionA\Minor = 0
    *VersionA\Patch = 0
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Copy : A = Source : B = Destination <<<<<

  Procedure Copy(*VersionA.Version, *VersionB.Version)

    *VersionB\Major = *VersionA\Major
    *VersionB\Minor = *VersionA\Minor
    *VersionB\Patch = *VersionA\Patch

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Compare <<<<<

  Procedure Compare(*VersionA.Version, *VersionB.Version)

    If *VersionA\Major <> *VersionB\Major
      ProcedureReturn #False
    EndIf

    If *VersionA\Minor <> *VersionB\Minor
      ProcedureReturn #False
    EndIf

    If *VersionA\Patch <> *VersionB\Patch
      ProcedureReturn #False
    EndIf

    ProcedureReturn #True
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Swapping <<<<<

  Procedure Swapping(*VersionA.Version, *VersionB.Version)

    Swap *VersionA\Major, *VersionB\Major
    Swap *VersionA\Minor, *VersionB\Minor
    Swap *VersionA\Patch, *VersionB\Patch

  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture sur fichier Binaire <<<<<

  Procedure ReadVersion(FileID.l, *VersionA.Version)
    
    *VersionA\Major = ReadAsciiCharacter(FileID)
    *VersionA\Minor = ReadAsciiCharacter(FileID)
    *VersionA\Patch = ReadAsciiCharacter(FileID)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture sur fichier Binaire <<<<<

  Procedure WriteVersion(FileID.l, *VersionA.Version)
    
    WriteAsciiCharacter(FileID, *VersionA\Major)
    WriteAsciiCharacter(FileID, *VersionA\Minor)
    WriteAsciiCharacter(FileID, *VersionA\Patch)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de Formatage <<<<<
  
  Procedure.s Format(*VersionA.Version)
    
    ProcedureReturn "V" + Str(*VersionA\Major) + "." + Str(*VersionA\Minor) + "." + Str(*VersionA\Patch)
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de Dformatage <<<<<
  
  Procedure Unformat(*VersionA.Version, P_Version.s)
    
    *VersionA\Major = Val(StringField(StringField(P_Version, 2, "V"), 1, "."))
    *VersionA\Minor = Val(StringField(StringField(P_Version, 2, "V"), 2, "."))
    *VersionA\Patch = Val(StringField(StringField(P_Version, 2, "V"), 3, "."))
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Combiner la version dans un entier <<<<<
  
  Procedure.l To_Long(*VersionA.Version)
    
    ProcedureReturn (*VersionA\Patch) << 16 + (*VersionA\Minor) << 8 + (*VersionA\Major)
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Retrouver la version depuis un entier <<<<<
  
  Procedure From_Long(*VersionA.Version, LongVar.l)
    
    *VersionA\Major = (LongVar) & $FF
    *VersionA\Minor = (LongVar >> 8) & $FF
    *VersionA\Patch = (LongVar >> 16) & $FF
    
  EndProcedure
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Version::Update(Alpha.Version::Version, 1, 2, 3)
  Ver.l = Version::To_Long(Alpha)
  FormatedVersion.s = Version::Format(Alpha)
  Version::Unformat(Beta.Version::Version, FormatedVersion)
  Version::From_Long(Gamma.Version::Version, Ver)
  
  Debug FormatedVersion
  Debug Version::Format(Beta)
  Debug Ver
  Debug Version::Format(Gamma)
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 (Linux - x64)
; Folding = ---
; EnableXP
; CompileSourceDirectory