#include "Structures.h"
#include "time.h"

Time::Time()
{
    hour = minute = second = 0;
}

Time::Time(int h, int m, int s)
{
    hour    = ( h >=0 && h < 24 ) ? h : 0;
    minute  = ( m >=0 && m < 60 ) ? m : 0;
    second  = ( s >=0 && s < 60 ) ? s : 0;
}

void Time::Update(int h, int m, int s)
{
    hour    = ( h >=0 && h < 24 ) ? h : 0;
    minute  = ( m >=0 && m < 60 ) ? m : 0;
    second  = ( s >=0 && s < 60 ) ? s : 0;
}

void Time::Update(const STime & P_Time)
{
    Update(P_Time.Hour, P_Time.Minute, P_Time.Second);
}

void Time::SetHour(int h)
{
    hour = ( h >= 0 && h < 24 ) ? h : 0;
}

void Time::SetMinute(int m)
{
    minute = ( m >= 0 && m < 60 ) ? m : 0;
}

void Time::SetSecond(int s)
{
    second = ( s >= 0 && s < 60 ) ? s : 0;
}

int Time::GetHour() const
{
    return hour;
}

int Time::GetMinute() const
{
    return minute;
}

int Time::GetSecond() const
{
    return second;
}

void Time::Refresh()
{
    hour = minute = second = 0;
}

void Time::Version(SVersion * Version)
{
   Version->Major = 1;
   Version->Minor = 0;
   Version->Patch = 1;
}


Time::~Time()
{
    hour = minute = second = 0; // Maybe over kill in this case
}
